Bug 4179 - update-menus is vulnerable to broken menu files
: update-menus is vulnerable to broken menu files
Status: CLOSED FIXED
: Sisyphus
(All bugs in Sisyphus/menu)
: unstable
: all Linux
: P2 blocker
Assigned To:
:
: http://bugzilla.altlinux.ru/show_bug....
:
:
: 3459 7079
  Show dependency tree
 
Reported: 2004-05-17 00:58 by
Modified: 2008-06-13 12:16 (History)


Attachments
rpmdrake (914 bytes, text/plain)
2006-09-05 18:53, Sergey V Turchin
no flags Details


Note

You need to log in before you can comment on or make changes to this bug.


Description From 2004-05-17 00:58:29
update-menus is known to be vulnerable to broken menu files.

That is, malformed file in /usr/lib/menu/ may cause update-menus to crash and
leave menus unfinished and incomplete.  This very bad behaviour should be fixed.
------- Comment #1 From 2004-05-17 13:44:47 -------
Как воспроизвести падение? 
 
------- Comment #2 From 2004-05-17 15:00:28 -------
#4169 - не оно?

Я не утверждаю, что оно падает, я утверждаю, что один сломанный файл может
сломать всё меню.
------- Comment #3 From 2004-05-17 15:32:40 -------
У меня #4169 не ломает генерацию всего остального меню 
------- Comment #4 From 2004-05-17 19:00:01 -------
Denis, could you help us, please?
------- Comment #5 From 2004-05-17 19:21:06 -------
можно наблюдать 
update-menus -v -n 
 
------- Comment #6 From 2004-05-17 19:29:03 -------
Can be reproduced on demand any time when I'm at home until my local Sisyphus
copy is the same.
------- Comment #7 From 2004-05-17 21:28:51 -------
Проверил дома. На этот раз update-menus по-прежнему ругается на файл меню,
но меню не рушатся. Проверил для fluxbox и для gnome2 --- эффект не
повторяется (исходная ситуация наблюдалась на gnome2).
Но в этот раз есть одно отличие: если сейчас update-menus жалуется на файл
меню, но продолжает работать, то раньше он прекращал работу сразу же после
сообщения об ошибке.
------- Comment #8 From 2004-05-17 21:55:10 -------
Это видимо на menu-2.1.5 было 
------- Comment #9 From 2004-05-17 22:43:45 -------
Сизиф как был 20040506, так и остался. menu-2.1.9-alt10 в обоих случаях.
------- Comment #10 From 2004-05-25 13:42:13 -------
Я собираюсь сегодня обновиться до вчерашнего Сизифа. Перед этим ещё
какую-нибудь
диагностику ещё сделать?
------- Comment #11 From 2004-05-25 18:54:47 -------
не знаю, вот если бы воспроизводилось 
------- Comment #12 From 2004-06-03 19:38:03 -------
Не могу воспроизвести 
------- Comment #13 From 2004-06-03 20:07:10 -------
Я уже сизиф обновил, по-прежнему не могу поймать снова, хотя menu опять
ругается
на файл от supertux-xxxx-alt2 (в котором должен был файл исправиться). Пока
больше ничем помочь не могу, разве что посоветовать попробовать самостоятельно
написать зловредный файл, глядя на исходник.
------- Comment #14 From 2004-06-03 20:41:01 -------
(In reply to comment #13) 
> Я уже сизиф обновил, по-прежнему не могу поймать снова, хотя menu опять 
ругается 
> на файл от supertux-xxxx-alt2 (в котором должен был файл исправиться) 
У меня то же самое 
------- Comment #15 From 2004-06-18 14:36:16 -------
Для воспроизведения проблемы можно поставить старый пакет rpmdrake, его файл 
меню останавливает update_menus, и меню не генерируется. 
------- Comment #16 From 2004-06-18 15:01:51 -------
А можно его не ставить, а прикрепить сю (In reply to comment #15) 
> Для воспроизведения проблемы можно поставить старый пакет rpmdrake, его файл  
> меню останавливает update_menus, и меню не генерируется.  
А можно его не ставить, а прикрепить сюда этот меню-файл? 
------- Comment #17 From 2004-06-18 17:03:18 -------
(In reply to comment #16) 
> А можно его не ставить, а прикрепить сюда этот меню-файл?  
Не нужно, я воспроизвел. 
 
------- Comment #18 From 2005-05-18 01:18:20 -------
В файле меню aMule указана section="Networking/File Transfer" (Transfer с
большой буквы). В результате из меню KDE полностью исчезает категория
"Сеть->Передача файлов" вместе со значками всех прочих программ данной секции.
При этом update-menus сообщений об ошибке не выводит. Если исправить Transfer
на
transfer, то всё возвращается в норму.
Так задумано, что категории меню должны быть чувствительными к регистру?
------- Comment #19 From 2005-06-14 12:39:22 -------
2Zerg: ничего не исправлялось ?
------- Comment #20 From 2005-06-14 16:32:33 -------
C menu-файлом rpmdrake из M-2.0 menu не падает, но генерация накрывается, а 
это уже бог знает, когда исправят. Слишком дофига нам exception-ов. 
------- Comment #21 From 2005-06-15 13:36:29 -------
It is not really fixed, right?
------- Comment #22 From 2005-06-15 14:01:54 -------
Я ничем не могу помочь, кроме совета просмотреть код.
------- Comment #23 From 2005-06-15 15:35:59 -------
(In reply to comment #21) 
> It is not really fixed, right? 
Да, но не падает. 
Там exception слишком общего характера, поэтому я пока не знаю, как исправить. 
 
 
------- Comment #24 From 2006-06-23 12:59:18 -------
Выбросив menu?..
------- Comment #25 From 2006-06-23 13:51:53 -------
(In reply to comment #24)
> Выбросив menu?..
Рановато пока.
$ grep /usr/lib/menu/ ./contents_index | wc -l
605
------- Comment #26 From 2006-06-23 13:54:14 -------
Но зато уже
grep /usr/share/applications/ ./contents_index | wc -l
717
Т.е. уже преимущество за desktop-файлами
------- Comment #27 From 2006-09-05 18:51:18 -------
У меня перестало воспроизводиться
menu-2.1.29
------- Comment #28 From 2006-09-05 18:53:36 -------
Created an attachment (id=1617) [details]
rpmdrake

menu-файл, с которым воспроизводилось из-за того, что там \n , а не \\n